#include "effects.h"
#include "waveops.h"
#include "lcd.h"
#include "sin.h"
#include "rotoblitter.h"

#include "shagadelic.h"

void effectPlasma(int n) {
    int x,y,c,b,x1,y1,x2,y2;
    float xx;
    signed char samp[128];
    x1 = ((icos(n*17)>>11)+128);
    y1 = ((isin(n*15)>>11)+128);
    x2 = ((icos(n*14)>>11)+128);
    y2 = ((isin(n*19)>>11)+128);    
    SampleWave(128,samp);
    for (x=0; x<98; x++) {
	for (y=0; y<67; y++) {
	    c=(isin(n+(x-x1))>>9);
	    c+=(isin(n*5+(x-x1)*7+(y-y1)*5)>>9);
	    b=isin(n*21)>>9;
	    c+=(isin(-n*4-(y-y1)*15-b*2)>>9);
	    c+=(isin(-n*4-(y-y2)*30+(x-x2)*20)>>10);
	    c+=(isin(n*14-(x-x2)*9+(y-y2)*11+b)>>9);
	    c+=samp[b>>5];
	    dispram[x+y*98]=c&127;
	}
    }

    senddisp();
}


//define CAKE_USE_FFT

//Don't ask why it's named like this ;-)
void effectCake(int n) {
    int x,c,y,sy,a,i;
    short r,g,b;
#ifdef CAKE_USE_FFT
    signed char fft[98];
    signed char samp[98];
#else
    signed char samp[128];
#endif


#ifdef CAKE_USE_FFT
    //'borrow' the display ram to use as a temp buffer for the fft routines.
    //This means dispram's gotta be rebuilt after this, which is no problem:
    //rotoblit overwrites the display ram anyways.
    SampleAndFFT(98,fft,samp,(signed short *)dispram);
    
    //Use the bass part of the fft to calculate zoom factor.
    i=0;
    for (x=0; x<20; x++) i+=fft[x];
#else
    SampleWave(128,samp);
    //Get longest span between zero-crossings
    i=0; c=0;
    for (x=1; x<128; x++) {
	if (samp[x]>0 && samp[x-1]<=0) {
	    if (c>i) i=c;
	    c=0;
	} else {
	    c++;
	}
    }
#endif
    i<<=2;
    rotoblit(header_data, width, height, isin(n*5)>>4, i+256, (isin(n*20)>>11)+49, (isin(n*10)>>11)+33);
    senddisp();
}


void effectFall(int n) {
    int x,y,p;
    signed char samp[97];
    for (x=1; x<98; x++) {
	for (y=65; y>=0; y--) {
	    p=dispram[x+y*98];
	    if (p<2 || p==128) p=128; else p=p-1;
	    dispram[x+(y+1)*98]=p;
	}
    }

    for (x=0; x<98; x++) dispram[x+66*98]=128;
    for (y=0; y<67; y++) dispram[97+y*98]=128;
    
    SampleWave(98,samp);
    for (x=0; x<98; x++) {
	p=(((samp[x]>0)?samp[x]:-samp[x])+90)&127;
	if (p<128) dispram[x]=p; else dispram[p]=127;
    }
    senddisp();

}

void effectRoundWave(int n) {
    int x,y,p;
    signed char samp[128];
    
    for (x=1; x<98; x++) {
	for (y=1; y<67; y++) {
	    p=dispram[x+y*98];
	    if (p<4 || p==128) p=128; else p=p-3;
	    dispram[(x-1)+(y-1)*98]=p;
	}
    }

    for (x=0; x<98; x++) dispram[x+66*98]=128;
    for (y=0; y<67; y++) dispram[97+y*98]=128;

    SampleWave(128,samp);


    for (p=0; p<128; p++) {
	x=isin(p*8)*((samp[p]>>2)+20);
	y=icos(p*8)*((samp[p]>>2)+20);
	x=(x>>16)+65;
	y=(y>>16)+44;
	
	if (x<0) x=0;
	if (y<0) y=0;
	if (x>97) x=97;
	if (y>66) y=66;
	
	dispram[x+y*98]=127;
    }

    senddisp();
}

void effectFftAndWave(int n) {
    int x,y;
    signed char fft[98];
    signed char samp[98];

    //'borrow' the display ram to use as a temp buffer for the fft routines.
    //This means dispram's gotta be rebuilt after this.
    SampleAndFFT(98,fft,samp,(signed short *)dispram);

    //Clear dispram
    for (y=0; y<67*98; y++) dispram[y]=128;

    //Display ftt samples
    for (x=0; x<98; x++) {
        for (y=0; y<((fft[x]>67)?67:fft[x]); y++) dispram[x+(66-y)*98]=((fft[x]-y)*3)&127;
    }
	
    //Display wave samples
    for (x=1; x<98; x++) {
	for (y=samp[x-1]; y<=samp[x]; y++) dispram[x+((y/2)+16)*98]=((x*4)+n)&127;
	for (y=samp[x]; y<=samp[x-1]; y++) dispram[x+((y/2)+16)*98]=((x*4)+n)&127;
    }

    senddisp();
}
