#include "waveops.h"
#include "fix_fft.h"
#include "io.h"

#define RECALIBRATEAFTER 200
#define LIMIT 2

void WaitZeroCross(void) {
    //Wait till zero-crossing, with time-out.
    int t=0;
    while (getad()>LIMIT && t<RECALIBRATEAFTER) t++;
    while (getad()<-LIMIT && t<RECALIBRATEAFTER) t++;
    if (t==RECALIBRATEAFTER) calibratead();
}


void SampleWave(unsigned char no,signed char wave[]) {
    int x;
    WaitZeroCross();
    for (x=0; x<no; x++) wave[x]=getad();
}



//Buffer should be 512 shorts (1<<9), that's 1KByte.
#define LN 9
#define N (1<<LN)

void SampleAndFFT(unsigned char no, signed char fft[], signed char wave[], signed short samps[]){
    int x,y,t;

    WaitZeroCross();

    for (x=0; x<(N/2); x++) {
	samps[x]=getad()<<5;
	samps[x+(N/2)]=getad()<<5;
    }
	
    for (x=0; x<(N/4); x++) {
        y=(x*no)/(N/4);
        t=(samps[x]>>8);
	wave[y]=t;
        if (wave[y]<-32) wave[y]=-32;
        if (wave[y]>32) wave[y]=32;
    }

    fix_fftr(samps, LN, 0);

    for (x=0; x<no; x++) fft[x]=0;
    
    for (x=0; x<(N/4); x++) {
        y=(x*no)/(N/4);
        fft[y]+=samps[x]/16;
    }
}
